--
-- psb
-- Specialization for psb Particlesystem & animation
--
-- @author  Stefan Maurus    
-- @date  2015/12/07

-- Copyright  Stefan Maurus, www.stefanmaurus.de


psb = {};

function psb.prerequisitesPresent(specializations)
    return true;
end;

function psb:load(savegame)    
    self.bunkerSiloCompactingScaleOnContact = self.bunkerSiloCompactingScale; --FahrsiloExtension

    self.distributorGroundReference = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.distributorGroundReference#index"));
    self.distributorGroundReferenceThreshold = Utils.getNoNil(getXMLString(xmlFile, "vehicle.distributorGroundReference#threshold"), 0)+0.05;
    
    self.grassParticleSystem = {};
    local ps = Utils.loadParticleSystem(xmlFile, self.grassParticleSystem, "vehicle.grassParticleSystem", self.components, false, nil, self.baseDirectory);
    
    self.dustParticleSystem = {};
    local ps = Utils.loadParticleSystem(xmlFile, self.dustParticleSystem, "vehicle.dustParticleSystem", self.components, false, nil, self.baseDirectory);
    
    self.dustParticleSystem1 = {};
    local ps = Utils.loadParticleSystem(xmlFile, self.dustParticleSystem1, "vehicle.dustParticleSystem1", self.components, false, nil, self.baseDirectory);
end;

function psb:delete()
    Utils.deleteParticleSystem(self.grassParticleSystem);
    Utils.deleteParticleSystem(self.dustParticleSystem);
    Utils.deleteParticleSystem(self.dustParticleSystem1);
end;

function psb:mouseEvent(posX, posY, isDown, isUp, button)
end;

function psb:keyEvent(unicode, sym, modifier, isDown)
end;

function psb:update(dt)
end;

function psb:updateTick(dt)
    if self.isClient then
        if self:getIsActive() and (self.lastSpeed*3600) > 0.4 then
            local groundRaycastResult = {
                raycastCallback = function (self, transformId, x, y, z, distance)
                    self.distance = distance;
                    --[[local object = g_currentMission:getNodeObject(transformId);
                    if object ~= nil then
                        if object.fillLevel ~= nil and object.movingPlanes ~= nil then
                            for i, v in ipairs(object.movingPlanes) do
                                if v.nodeId == getParent(transformId) then
                                    if v.fillLevel > 0 then
                                        self.distance = distance;
                                    end;
                                end;
                            end;
                        end;
                    end;]]
                end
            };
            groundRaycastResult.distance = self.distributorGroundReferenceThreshold;

            local x, y, z = getWorldTranslation(self.distributorGroundReference);    
            raycastAll(x, y, z, 0, -1, 0, "raycastCallback", self.distributorGroundReferenceThreshold, groundRaycastResult);
            
            if groundRaycastResult.distance < self.distributorGroundReferenceThreshold then
                Utils.setEmittingState(self.grassParticleSystem, true);
                Utils.setEmittingState(self.dustParticleSystem, true);
                Utils.setEmittingState(self.dustParticleSystem1, true);
            else
                Utils.setEmittingState(self.grassParticleSystem, false);
                Utils.setEmittingState(self.dustParticleSystem, false);
                Utils.setEmittingState(self.dustParticleSystem1, false);
            end;
        else
            Utils.setEmittingState(self.grassParticleSystem, false);
            Utils.setEmittingState(self.dustParticleSystem, false);
            Utils.setEmittingState(self.dustParticleSystem1, false);
        end;
    end;
end;

function psb:onAttach()    
end;

function psb:onDetach()        
end;

function psb:draw()
end;